{$A+,B-,D-,E-,F-,G+,I+,L-,N-,O-,P-,Q-,R-,S+,T-,V+,X-,Y-}
{$M 16384,0,655360}

PROGRAM Differ;
{ find the difference between file1 and file2 and write result to file3 }
{ will find all text that is in file2 but not in file1 }
{ note that file2 has to include all text of file1 (use MergeRead in the }
{ Dictionary Manager) and both files are sorted in the same manner }

USES Crt;

VAR f1, f2, f3: Text;
    s1, s2: string;

FUNCTION Zeilelesen(VAR f: Text): string;
{ this can handle unix-style files }
{ reading the file character by character makes this very slow }
{ if you only have dos-style files you should use Readln(f,s) instead }
{ one could also make use of BlockRead procedure ... }

VAR c: char;
    s: string;
    ok: boolean;

BEGIN
  REPEAT
    s := '';
    REPEAT
      Read(f,c);
      If NOT(c IN [#10, #13]) Then s := s + c;
    UNTIL ((c = #10) OR (EOF(f)));
  UNTIL (EOF(f) OR (s[1] <> '%'));
  { remove any blanks at the beginning and end of the word }
  ok:=(Length(s) > 0);
  WHILE (ok) Do
  BEGIN
    If (s[1] <> ' ') Then ok:=FALSE
    ELSE BEGIN
      Delete(s,1,1);
      ok:=(Length(s) > 0);
    END;
  END;
  ok:=(Length(s) > 0);
  WHILE (ok) Do
  BEGIN
    If (s[Length(s)] <> ' ') Then ok:=FALSE
    ELSE BEGIN
      Delete(s,Length(s),1);
      ok:=(Length(s) > 0);
    END;
  END;
  Zeilelesen:=s;
END;

BEGIN
  ClrScr;
  Assign(f1, 'small.dic');
  Assign(f2, 'big.dic');
  Assign(f3, 'diff.dic');
  Reset(f1);
  Reset(f2);
  Rewrite(f3);
  WHILE NOT EOF(f1) Do
  BEGIN
    s1:=Zeilelesen(f1);
    REPEAT
      s2:=Zeilelesen(f2);
      If (s1 <> s2) Then Writeln(f3, s2);
      If (EOF(f2) AND NOT(EOF(f1))) Then
      BEGIN
        REPEAT
          s1:=Zeilelesen(f1);
        UNTIL (EOF(f1) OR (s1 <> ''));
        Close(f1);
        Close(f2);
        Close(f3);
        If (s1 <> '') Then Writeln('Problems encountered.'#7)
                      ELSE Writeln('The End');
        HALT;
      END;
    UNTIL (s1 = s2);
  END;
  WHILE NOT EOF(f2) Do
  BEGIN
    s2:=Zeilelesen(f2);
    Writeln(f3, s2);
  END;
  Close(f1);
  Close(f2);
  Close(f3);
  Writeln('The End');
END.